﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Runtime.CompilerServices;
using System.Text;
using System.Windows.Forms;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;

namespace DotNet_InPlaceTextEditor
{

    public partial class MTextIPE : Form
    {
        public MTextIPE()
        {
            InitializeComponent();
            
        }
       
        // Invokes the dialog based on the number returned from the combo box
        private void dlgInvoke_Click(object sender, EventArgs e)
        {
            
            int dlgNumber = cmbDlgList.SelectedIndex ;                                
            IPEDialogsTesting(dlgNumber);                     
        }

        // Open the appropriated Dialog based on the selected Index
        // The changes in the dialog will applied to the selected text
        
        // Dilaog Integer information 
        // 0 -  Other Symbol Dialog
        // 1 -  Paragraph Dialog
        // 2 -  Wipeout Dialog
        // 3 -  ColumnsDialog
        // 4 -  FindAndReplaceDialog
        // 5 -  ImportTextDialog
        // 6 -  SpellDictinaryDialog
        // 7 -  HightlightColorDialog
        // 8 -  HelpDialog
        // 9-   HightlightColorDialog
        // 10-  HelpDialog
        // 11 - NewFeatureWorkShop
        // 12-  StackPropertyDialog

        static void IPEDialogsTesting(int dlgToDisplay)
        {
            InplaceTextEditor editor = null;
            try
            {
                editor = InplaceTextEditor.Current;               
                Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
                Database db = doc.Database;
                switch (dlgToDisplay)
                {
                    case 0:
                        editor.OtherSymbol();
                        break;
                    case 1:
                        editor.ParagraphDialog();
                        break;
                    case 2:
                        TextEditorWipeout wp;
                        wp = editor.Wipeout;
                        editor.WipeoutDialog();                                
                        break;
                    case 3:
                        editor.ColumnsDialog(0);
                        break;
                    case 4:
                        editor.FindAndReplaceDialog();
                        break;
                    case 5:
                        editor.ImportTextDialog();
                        break;
                    case 6:
                        editor.FindAndReplaceDialog();
                        break;
                    case 7:
                        editor.SpellDictinaryDialog();
                        break;
                    case 8:
                        editor.SpellSettingDialog();
                        break;                         
                    case 9:
                        editor.HightlightColorDialog();
                        break;
                    case 10:
                        editor.HelpDialog();
                        break;
                    case 11:
                        editor.NewFeatureWorkShop();
                        break;
                    case 12:
                        // For stackProperty dialog , the text need to 
                        // be selected, editor.SelectAll() will select the 
                        // Text in the Inplace TextEditor Screen
                        if (editor == null)
                            return;
                        editor.SelectAll();
                        TextEditorSelection selection = editor.Selection;                     
                        if (selection != null)
                        {
                            selection.Stack();
                            editor.StackPropertyDialog();
                        }
                        break;
                    default:                              
                        break;
                }
                    //Apply the changes and exit
                   editor.Close(TextEditor.ExitStatus.ExitSave);  
        }
        catch(System.Exception es)
        {
            if (editor != null)
            {
                System.Windows.Forms.MessageBox.Show(es.ToString());
                //Exit with out save the changes
                editor.Close(TextEditor.ExitStatus.ExitQuit);
            }
        }
        }                  
        private void MTextIPE_Load(object sender, EventArgs e)
        {
            // Populate the various dialogs name inside the combobox 
            populatecmbDlgList();
        }
      
        private void populatecmbDlgList()
        {

            cmbDlgList.Items.Add("OtherSymbol");
            cmbDlgList.Items.Add("ParagraphDialog");
            cmbDlgList.Items.Add("BackGround Dialog");            
            cmbDlgList.Items.Add("ColumnsDialog");
            cmbDlgList.Items.Add("FindAndReplaceDialog");
            cmbDlgList.Items.Add("ImportTextDialog");
            cmbDlgList.Items.Add("FindAndReplaceDialog");
            cmbDlgList.Items.Add("SpellDictinaryDialog");
            cmbDlgList.Items.Add("SpellSettingDialog");
            cmbDlgList.Items.Add("HightlightColorDialog");
            cmbDlgList.Items.Add("HelpDialog");
            cmbDlgList.Items.Add("NewFeatureWorkShop");
            cmbDlgList.Items.Add("StackPropertyDialog");

        }
        private void cmbDlgList_SelectedIndexChanged(object sender, EventArgs e)
        {

        }



    }
}
